/*
 nRF Doorbell Button TX
 Version: 1.0
 Author: Alex from insideGadgets (http://www.insidegadgets.com)
 Created: 15/11/2015
 Last Modified: 15/11/2015
 
 Transmit a single byte packet when the button is pressed. 
 
 */
 
// ATtiny24/44/84 Pin map
//
//               +-\/-+
//         VCC  1|o   |14  GND
//         PB0  2|    |13  PA0 
//     LED PB1  3|    |12  PA1 
//   Reset PB3  4|    |11  PA2 
//      CE PB2  5|    |10  PA3 Button
//     CSN PA7  6|    |9   PA4 SCK
//      MI PA6  7|    |8   PA5 MO
//               +----+

#define F_CPU 1000000 // 1 MHz

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/sleep.h>
#include "setup.c"
#include "mirf.c"

int main(void) {
	setup();
	
	while(1) {
		// Power down the nRF24L01/MCU and wait for pin interrupt
		NRF_POWERDOWN;
		system_sleep();
		
		mirf_transmit_data();
		PORTB |= (1<<LED);
		_delay_ms(500);
		PORTB &= ~(1<<LED);
	}
}

ISR(PCINT0_vect) { }
